
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Tomcat如何实现资源安全管理 / iVAN</title>

    <meta name="description" content="Tomcat如何实现资源安全管理 在了解了认证模式及Realm域后,我们看看Tomcat是如何设计实现资源安全管理的.在认证模式上,必须要支持多种认证模式,包括Basic模式.Digest模式.Form模式.Spnego模式.SSL模式及NonLogin模式.如何实现这些认证模式比较优雅,或者说比较清晰?看下图,在tomcat中一个请求从浏览器发送过来后,请求接收后会流向四个级别容器处理,即Engine-&gt;Host-&gt;Context-&gt;Wrapper,而且是以管道阀门(pipeline和valve)形式进行处理 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Tomcat如何实现资源安全管理</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在了解了认证模式及Realm域后，我们看看Tomcat是如何设计实现资源安全管理的。在认证模式上，必须要支持多种认证模式，包括Basic模式、Digest模式、Form模式、Spnego模式、SSL模式及NonLogin模式。如何实现这些认证模式比较优雅，或者说比较清晰？看下图，在tomcat中一个请求从浏览器发送过来后，请求接收后会流向四个级别容器处理，即Engine-&gt;Host-&gt;Context-&gt;Wrapper，而且是以管道阀门（pipeline和valve）形式进行处理，只需往某个容器中添加一个阀门valve用于认证处理，由于要支持每个应用都可以有各自的认证机制，所以这个容器级别应该选为Context。</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjYwOTA3MDE4ODY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg"></p>
<p>针对每种认证模式建立不同的认证器，例如Basic模式对应BasicAuthenticator、SSL模式对应SSLAuthenticator等等，这些认证器都要实现valve接口以便被Context的管道调用。认证器主要负责通过认证协议与客户端交互，收集用户的凭证信息并进行认证鉴权工作。所以这整个认证过程包含了两大步骤，一是收集用户凭证信息，另一个是对凭证鉴权，收集凭证其实就是用不同的协议约定让客户端协助收集，例如HTTP Basic协议。而对凭证的鉴权工作又是如何设计的？</p>
<p>    鉴权工作主要是通过客户端用户名和密码找出相应的权限，然后根据查询出来的权限检查是否可以请求相应资源。正如下图，web层对应Context容器级别，所以在web应用中web.xml配置文件配置的权限信息会被加载到Context容器中，例如role1对应url1，role2对应url2、url3。除此之外，它还需要查询用户权限模块，这块就交由realm完成，realm抽象了用户与角色关系的一层。客户端传输过来用户名和密码后，xxxAuthenticator认证器通过realm获取到该用户的角色，然后判断是否有请求资源的权限，假如user1正在访问url1，通过user1和pwd1查出来的权限为role1，有url1权限则返回该资源。</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjYwOTA4MTAzNzA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvU291dGhFYXN0.jpg"></p>
<p>    Tomcat资源安全管理的实现思路很清晰，通过不同认证协议让客户端输入身份信息，接收到身份信息后则通过realm模块和web.xml权限配置共同判断是否返回正在请求的资源。</p>
<p><a href="https://item.jd.com/12185360.html" rel="external nofollow noreferrer">点击订购作者《Tomcat内核设计剖析》</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-27 07:10:46</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/web/" title="web">web</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8/" title="容器">容器</a>, <a href="https://www.iamivan.net/tag/tomcat/" title="tomcat">tomcat</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Tomcat如何实现资源安全管理的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr39E4p.html" rel="bookmark">75篇关于Tomcat源码和机制的文章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				整理下前面写过的75篇关于Tomcat源码和机制的文章 文章列表 如何设计一个Web容器 Web安全认证机制知多少 Tomcat集群实现源码级别剖析 Tomcat集群如何同步会话 从单机到集群会话的管理之集群模式一 从单机到集群会话的管理之集群模式二(更大的集群) Tomcat集群的failover机制 Tomcat集群应用部署的实现机制 Tomcat集群机制剖析及其生产部署选型 Tomcat如何实现WebSocket Tomcat如何实现Comet Tomcat怎么实现异步Servlet To			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boLkPEM.html" rel="bookmark">tomcat的realm域</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Realm域,其实可以看成是一个包含了用户及密码的数据库,而且每个用户还会包含了若干角色.也就是包含了用户名.密码.角色三个列的数据记录集合,如下图,最下面椭圆内的包含的整块即可以看成realm域.它的出现是为了方便统一地提供一种X(用户,密码,权限)与Y(web资源)的映射关系.       我们有三个web应用的资源及对应资源访问角色,web1应用中url1资源必须拥有role1角色的用户才可以访问,web2应用中rul2资源则需要role2角色才可访问,而web3应用的rule3角色可以访			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDY16Bb.html" rel="bookmark">静态资源过滤方式补充</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				昨天写过一篇 更改静态资源过滤方式. 在写 mvc:resources 配置,少写了一些.因此,在项目访问时,报错404. &lt;!-- 过滤静态资源 --&gt; &lt;mvc:resources mapping=&quot;/js/**&quot; location=&quot;/js/&quot; /&gt; &lt;mvc:resources mapping=&quot;/pages/assets/**&quot; location=&quot;/pages/assets/&quot; /&g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmGJe1b.html" rel="bookmark">更改静态资源过滤方式。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				项目中,考虑了3种过滤资源方式. 1.在web.xml中过滤. 配置如下: &lt;servlet&gt; &lt;servlet-name&gt;springmvc&lt;/servlet-name&gt; &lt;servlet-class&gt; org.springframework.web.servlet.DispatcherServlet &lt;/servlet-class&gt; &lt;init-param&gt; &lt;param-name&gt;contextConfigLocat			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8klX3M.html" rel="bookmark">tomcat 延时-新手请教，tomcat的延时设置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 新手请教,tomcat的延时设置 Windows系统中,用tomcat作为资源服务器,能否做到如下两点: 1.向tomcat发送http资源请求(http://ip:port/1.mp3之类的资源地址),tomcat能否延时一定时间(例如10s)然后再向客户端发送资源文件 2.能否限制单位时间内(1s)发送的资源大小.例如收到客户端请求(http://ip:port/1.mp3之类的资源地址)之后,每秒只向客户端发送1kb大小的文件数据流 以tomcat作为服务器能否做到如下两点?如果			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bamnQnb.html" rel="bookmark">Apache和Tomcat整合（一个Apache 不同域名处理多个不同业务）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.简介 在项目中,几乎任何一个项目都包括静态资源和动态请求两大部分.特别对于门户网站这样的项目,静态内容资源会更多,我们使用一般的 Tomcat 部署时,Tomcat 对静态资源的处理能力比较慢,至少比 Apache 要慢很多. 为了提高项目的访问速度,降低服务器负载提高性能,我们使用Apache来处理静态资源,把动态资源和请求交给 Tomcat 处理. 当然,在单纯处理并发和静态资源指标方面,Nginx要比Apache好,至于Nginx和Apache的具体区别,以及什么项目使用Nginx.什			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1rlYrp.html" rel="bookmark">swing开发的项目需要用到tomcat&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我刚进了一家公司,公司的项目是使用swing开发的,我需要做二次开发工作.突然发现了一件奇怪的事情,公司的swing图片界面系统居然需要启动tomcat?tomcat不是一般用来搭建b/s结构的系统吗?怎么c/s结构的系统也需要tomcat了?我真是不知道为什么?大家来说说是什么原因,谢谢! 解决方案 解决方案二:也许这个服务器端是由web服务器提供服务的,使用http协议.解决方案三:Swing访问WebService,挺正常的.解决方案四:分布式...解决方案五:服务组件可能是we			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XpmvXDz.html" rel="bookmark">Java Web前端的高性能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 在前端优化的第一部分中,主要讲解了对静态资源的一些优化措施,包括图片压缩.CSS Sprites 技术. GZIP 压缩等.这一部分,本文将讲解前端优化里重要的 Flush 机制.动静分离.HTTP 持久连接.HTTP 协议灵活应用. CDN 等.结合这些技术或思想,相信会使 Java Web 应用程序的性能更上一层楼. Flush 机制的使用 实际上 在 Web 技术中,Flush 机制并不新鲜,它的思想是无需等到网页内容全部加载完毕,一次性写回客户端,而是可以部分逐 次的返回.如果网页			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeax49z.html" rel="bookmark">JNDI绑定数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				经过3个多小时的努力,配置JNDI数据源(主要是通过DBCP连接池)终于搞定- 还是Tomcat官方的说明好,不过全是英文的,大概还看得懂． 百度上那么花花绿绿的太多了,一个也没成功!．．． 本例使用的数据库为Ms SQL Server 2000,对于其它数据库只是修改一下相应的参数即可, 服务器是Tomcat5.5, 与之间的版本配置连接池最简便 自己总结了一下,希望起到一个抛砖引玉的作用 总结: 第一步: 将驱动程序(jar包)放到tomcat安装目录下的common\lib文件夹下 第二步			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvPe9z.html" rel="bookmark" class="title">网站运营：谈谈网站的立意与生存</a>
					<div>
						网站运营 互联网即使是X.0也好,需要的只是一个因素,生存. 某位互联网高人说过,做互联网,无论竞争如何激烈,剩者为王,最重要自己能生存下去就有希望. 的确,如今互联网环境下能够小有收入并不困难,因为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyQJlM.html" rel="bookmark" class="title">ASP向NT域中加一个用户</a>
					<div>
						问题: 在ASP中如何添加NT域用户? 俟名 于1999-03-08 提出 答案: 可以使用微软的活动目录服务接口(ADSI),例如: Set DomainObj=GetObject(&quot;Wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLrmvb.html" rel="bookmark" class="title">在基于Mozilla的浏览器中使用XMLHttpRequest对象</a>
					<div>
						IE通过允许开发人员在Web页面内部使用安全的ActiveX组件扩展自身的功能.微软在无状态连接方面的产品是XMLHTTP组件. 使用XMLHTTP组件,开发人员可以不用从当前的Web页面导航而直接传 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62m7oM.html" rel="bookmark" class="title">win7系统怎样将显示器由32位改为16位？</a>
					<div>
						  win7系统怎样将显示器由32位改为16位? 1.第一步:右键鼠标桌面-屏幕分辨率 2.第二步:选择如图所示的高级设置. 3.第三步:选择如图所示的&quot;监视器&quot;. 4.第四步:选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7227ap.html" rel="bookmark" class="title">U盘中毒症状有哪些 U盘中毒怎么办</a>
					<div>
						方法一 1.将U盘插入自己的电脑,当出现操作提示框时,不要选择任何操作,关掉. 2.进入我的电脑,从地址下拉列表中选择U盘并进入,或者右键单击可移动磁 盘,在弹出的菜单中选择&quot;打开&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b244EQp.html" rel="bookmark" class="title">如何设计游戏官网？《天神纪》设计思路实战分享</a>
					<div>
						  前所未有的东方幻想作品 &lt;天神纪&gt;原名&lt;ASTA&gt;意为&quot;涅盘之路&quot;,既意味着游戏内的最高等级,又意味着通往修行最高境界的路途.&lt;天神纪&gt;追求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYne0b.html" rel="bookmark" class="title">linux中locate命令使用介绍</a>
					<div>
						 locate 让使用者可以很快速的搜寻档案系统内是否有指定的档案.其方法是先建立一个包括系统内所有档案名称及路径的数据库,之后当寻找时就只需查询这个数据库,而不必实际深入档案系统之中了.在一般的 d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKG2OM.html" rel="bookmark" class="title">使用JavaScript获取地址栏参数的方法</a>
					<div>
						 代码如下: /**  *  获取地址栏参数  *  * @example GetUrlString('id')  *  * @desc    调用时加上判断,保证程序不会出错  *          ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRwl6p.html" rel="bookmark" class="title">Photoshop制作创意独特的彩色人像插画</a>
					<div>
						  本教程主要使用Photoshop制作创意独特的彩色人像插画,整体的效果很漂亮,喜欢的朋友一起来学习吧. 先看效果图: 人物素材: Photoshop将照片转成彩色潮流插画过程 教程开始:1.打开人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze79ExM.html" rel="bookmark" class="title">Iptool抓包工具捕包分析使用方法</a>
					<div>
						  1.设置捕包过滤项 这里的过滤和&quot;追踪任务&quot;过滤设置是独立分开的,请不要混淆,其可选内容项更多.点按钮,如下图: 上述选项中,最为复杂的是&quot;数据块匹配&quot;部分 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg39oBM.html" rel="bookmark" class="title">驱动精灵2015更新显卡蓝屏怎么办</a>
					<div>
						  首先我们来看看驱动精灵怎么更新显卡驱动? 第一步:打开我们的驱动精灵,点击一键检测 第二步:驱动精灵会检测出我们的电脑有哪些驱动故障,点击&quot;修复&quot;. 第三步:这个时候你会看到你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN137mb.html" rel="bookmark" class="title">如何更改cmd默认路径</a>
					<div>
						  一般情况下,系统被切换到MS-DOS命令行提示符状态下时,系统会自动将&quot;C:Documents and SettingsUser&gt;&quot;文件夹作为系统的当前默认路径(其中Us ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKklG7b.html" rel="bookmark" class="title">小度wifi不能用停在将小度wifi插到电脑中怎么办</a>
					<div>
						  这个问题有可能是网卡被系统关闭了,你需要把停用的设备改为启用.安装新版百度wifi驱动,「我的电脑」右键「设备管理器」,网络适配器找到802无线网卡,双击,属性设置对话框,设备用法改为「使用这个设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGdj1p.html" rel="bookmark" class="title">果库：小而美的移动App</a>
					<div>
						摘要: 如果你让我推荐移动端的电商类产品,我不会给你推荐淘宝.逛这类大电商产品,也不会推荐美丽说.蘑菇街这样的导购网站,我更愿意推荐的,是像果库这样小而美的移动App.众所周 如果你让我推荐移动端的电 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZNRJz.html" rel="bookmark" class="title">PHP 自动载入</a>
					<div>
						当一个项目需要根据不同的请求载入不同的类的时候,之前的做法是require不同的文件进来,但是如果数量巨大就没办法一个语句一个语句去写,而且如果有不小心误删的文件,就会导致PHP FATAL ERRO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGVK8p.html" rel="bookmark" class="title">Java Fork&sol;Join框架&lowbar;java</a>
					<div>
						Fork/Join框架是ExecutorService接口的一个实现,通过它我们可以实现多进程.Fork/Join可以用来将一个大任务递归的拆分为多个小任务,目标是充分利用所有的资源尽可能增强应用的性 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqADN2M.html" rel="bookmark" class="title">开源KVM管理工具介绍</a>
					<div>
						在之前的文章中,我们介绍了开源虚拟化平台KVM的概念与工作原理.下面我们来看看KVM的获取方式与管理工具. 两种方式获取KVM 购买Linux版本获得KVM.很多Linux发行版本都内置有KVM,包括 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmdo5z.html" rel="bookmark" class="title">tns 00530-dos环境下 启动数据库服务 lsnrctl start 出现错误</a>
					<div>
						问题描述 dos环境下 启动数据库服务 lsnrctl start 出现错误 C:UsersDavid&gt;lsnrctl start LSNRCTL for 64-bit Windows:0:54 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6Loaz.html" rel="bookmark" class="title">java-一个JFream里面怎么才可以添加两个JPanel&quest;怎样做到不覆盖？</a>
					<div>
						问题描述 一个JFream里面怎么才可以添加两个JPanel?怎样做到不覆盖? 内容如题,代码就是照片上的.我在jfream中用的是边框布局管理器,一个jpanel里用的是网格布局,另一个没有用,总是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwXeLM.html" rel="bookmark" class="title">loose index scan 优化distinct</a>
					<div>
						上篇中我们提到用伪loose index scan来优化max/min,这一篇我们将用伪loose index scan来优化distinct: 有这样的一个需求:select count(disti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlGBrp.html" rel="bookmark" class="title">android-如何在源码级合并两个独立的APK</a>
					<div>
						问题描述 如何在源码级合并两个独立的APK android studio开发环境 , 两个独立的APK,各有各的启动Activity, 因功能整合需要合并到一起, 我想是把其中一个改为库, 在另外的地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLq85p.html" rel="bookmark" class="title">关于struts的s&colon;iterator的问题</a>
					<div>
						问题描述 小弟初学,问题是这样的我用s:iterator迭代list里面的值,让它显示在页面,默认情况下它是显示list里面的全部值,没问题,但我用 begin=&quot;0&quot; end=& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRGoKp.html" rel="bookmark" class="title">批处理方式实现的目录比较工具&lowbar;DOS&sol;BAT</a>
					<div>
						更新日志: v4: 1.增加了计算的进度显示: 2.找了新版的 md5sum.exe,没有对动态库的依赖. 工具一:md5comv4.bat 接受两个目录参数,计算两个目录里每个文件的 md5 值,并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB93Db.html" rel="bookmark" class="title">关于异步发送邮件问题</a>
					<div>
						问题描述 前台使用Ajax异步请求后台发送邮件,当请求返回后关闭当前窗口并reload父窗口,而后台使用SmtpClient类调用SendAsync来异步发送邮件.但后台只有发送完毕并调用发送完毕回调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Zrxqp.html" rel="bookmark" class="title">javascript控制iframe自适应高度例子</a>
					<div>
						iframe有一个烦人的问题,就是在没有设置高度的情况下,被嵌套区会显示一大片空白,有时候设置了高度也不行,后来用JavaScript轻松解决了iframe自适应高度的问题,下面把经验和具体方法分享出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKJBrz.html" rel="bookmark" class="title">c&plus;&plus;-Qt编译时超出内存怎么处理？</a>
					<div>
						问题描述 Qt编译时超出内存怎么处理? cc1plus.exe:-1: error: out of memory allocating 1073745919 bytes 有个12MB的gif,怎么处理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnR4aM.html" rel="bookmark" class="title">smartmontools monitor storage device&amp;&num;039&semi;s health status</a>
					<div>
						不管是SSD硬盘还是机械硬盘, 都有使用寿命. 大多数的硬盘是支持S.M.A.R.T的, 全称(Self-Monitoring, Analysis and Reporting Technology)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJq3W8p.html" rel="bookmark" class="title">云呼叫中心系统&colon; 引领企业通信产业下一春</a>
					<div>
						米领通信了解到近年来,在云计算一路高歌猛进的时代背景下,云计算应用也开始走向企业实用化.在客户关系管理及维护方面,呼叫中心系统毋庸置疑仍是主角,而以云计算提供的云联络服务已经是呼叫中心发展的必然. 云 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeox8AM.html" rel="bookmark" class="title">关于 speex 和 ogg 的一个没事找事儿的回答</a>
					<div>
						关于 speex 和 ogg 的一个没事找事儿的回答 太阳火神的美丽人生 (http://blog.csdn.net/opengl_es) 本文遵循&quot;署名-非商业用途-保持一致&quot;创 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkyWlM.html" rel="bookmark" class="title">服务器socket接受多个客户端的连接以及接收数据的问题</a>
					<div>
						问题描述 我现在的问题是,我服务器是C#写的socket监听,现在有多个客户端连接上来,服务器接受数据接收不到,(前面几次接收是正常的)代码如下:(1)服务器端publicstaticvoidsock ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
